//
//  FGHUDSubView.h
//  Created by Francesco on 1/9/06.
//  Copyright 2006 Softech di Germinara Francesco
//
//  www.germinara.it
//  info@germinara.it
//
//  All rights reserved.
/////////////////////////////////////////////////////////

//Questa classe SubClassa la NSView, in modo da creare una finestra standard HUD, grigia, traslucida, con la parte superiore arrotondata ed il titolo in bianco al centro

#import <Cocoa/Cocoa.h>

typedef enum {
    FGRelevancyLevelIndicatorStyle,
    FGContinuousCapacityLevelIndicatorStyle,
    FGDiscreteCapacityLevelIndicatorStyle,
    FGRatingLevelIndicatorStyle,
	FGContinuousCapacityLevelIndicatorStyleCustomColor,
	FGContinuousLedsLevelIndicatorStyle
} FGLevelIndicatorStyle;


@interface FGHUDSubView : NSView {
  BOOL positionInitialized; //variabile di lavoro
  NSRect theScreen;         //dimensione del video
  NSPoint mostRecentPoint;  //ultimo punto su cui ho fatto clic
  float nAlpha;             //valore della trasparenza
  float nTitleHeight;       //ampiezza area titolo
  NSBezierPath *backGrnd;   //bezierpath per disegnare il layout
  NSColor *clrTitleBar;     //colore della zona titolo
  NSColor *clrBodyBar;      //colore della zona contenuti 

 NSString *strToolTip;      //Tool tip associato alla vista

}
-(NSColor*) clrTitleBar; //Restituisce  il colore della zona del titolo
-(NSColor*) clrBodyBar;  //Restituisce  il colore della zona contenuti


-(void) setToolTipText:(NSString *) aString; //Imposto l'eventuale testo di tool tip

@end
