//
//  FGHudSegmentedCell.m
//  FGBseHUD
//
//  Created by Francesco on 2/18/06.
//
//  Copyright 2006 Softech di Germinara Francesco
//
//  www.germinara.it
//  info@germinara.it
//
//  All rights reserved.
/////////////
#import "FGHudSegmentedCell.h"
#import "FGNSBezierPathAddition.h"

@implementation FGHudSegmentedCell

- (id)init{
    self = [super init];
    if (self) {
	    aImageLeft=[[NSImage  imageNamed:@"med_btn_left_on.tiff"] retain];
        aImageMiddle=[[NSImage  imageNamed:@"med_btn_middle_on.tiff"] retain];
		aImageRight=[[NSImage  imageNamed:@"med_btn_right_on.tiff"] retain];	

	    aImageLeftNormal=[[NSImage  imageNamed:@"med_btn_left.tiff"] retain];
        aImageMiddleNormal=[[NSImage  imageNamed:@"med_btn_middle.tiff"] retain];
		aImageRightNormal=[[NSImage  imageNamed:@"med_btn_right.tiff"] retain];	

	    aImageLeftPressed=[[NSImage  imageNamed:@"med_btn_left_press.tiff"] retain];
        aImageMiddlePressed=[[NSImage  imageNamed:@"med_btn_middle_press.tiff"] retain];
		aImageRightPressed=[[NSImage  imageNamed:@"med_btn_right_press.tiff"] retain];	
		ptLastHitPoint=NSZeroPoint;
		bCenterText=TRUE;

    }
    return self;
}

-(void) dealloc {
	[aImageLeft release];
	[aImageMiddle release];
	[aImageRight release];
	[aImageLeftNormal release];
	[aImageMiddleNormal release];
	[aImageRightNormal release];
	[aImageLeftPressed release];
	[aImageMiddlePressed release];
	[aImageRightPressed release];
	
	[super dealloc];
}


- (void)drawWithFrame:(NSRect)cellFrame inView:(NSView *)controlView{
  NSRect rcInvalidate= [[self controlView] bounds];
  aHudView=(FGHUDView *)[[super controlView] superview];
  foreColor=[aHudView clrTitleBar];
  backColor=[aHudView clrBodyBar];
  [backColor set];
  NSRectFill(rcInvalidate);
   
 int nSegment=[super segmentCount];
 int offset=0;
 int nIndex=0;
 
 for(nIndex=0;nIndex<nSegment; nIndex++){
   cellFrame.origin.x+=offset;
   cellFrame.size.width=[super widthForSegment:nIndex];
   [self  drawSegment:nIndex inFrame:cellFrame withView:controlView];
   offset=cellFrame.size.width+1;
 }
 
 }

- (void)drawSegment:(int)segment inFrame:(NSRect)frame withView:(NSView *)controlView{
  aHudView=(FGHUDView *)[[super controlView] superview];
  foreColor=[aHudView clrTitleBar];
  backColor=[aHudView clrBodyBar];
  int nSegment=[super segmentCount];
  BOOL bPressed=FALSE;
  
  NSPoint ptImagePos=NSZeroPoint;
  NSRect rcImagePos=frame;
  
  bPressed=([super isHighlighted] && NSPointInRect(ptLastHitPoint,frame));
  
  NSRect rcLeft,rcRight;
  int nAmpImg=12;
  int nAltImg=25;
  
  //Segmenti centrali
  if(segment > 0 && segment < (nSegment-1)){
   frame=NSInsetRect(frame,0,0);
   
   if(bPressed){
    [aImageMiddlePressed drawInRect:frame fromRect:NSMakeRect(0,0,1,nAltImg) operation:NSCompositeSourceOver fraction:1.0];
   }else{
    if([super isSelectedForSegment:segment])
     [aImageMiddle drawInRect:frame fromRect:NSMakeRect(0,0,1,nAltImg) operation:NSCompositeSourceOver fraction:1.0];
    else			  
     [aImageMiddleNormal drawInRect:frame fromRect:NSMakeRect(0,0,1,nAltImg) operation:NSCompositeSourceOver fraction:1.0];
   }
  
   
	 }
  
  //Primo segmento 
  if(segment == 0){
   if(bPressed){
    frame=NSInsetRect(frame,0,0);
    rcLeft=frame;
    rcLeft.size.width=nAmpImg;
	[aImageLeftPressed drawInRect:rcLeft fromRect:NSMakeRect(0,0,nAmpImg,nAltImg) operation:NSCompositeSourceOver fraction:1.0];		  
    frame.origin.x=rcLeft.size.width;
    frame.size.width-=rcLeft.size.width;
	[aImageMiddlePressed drawInRect:frame fromRect:NSMakeRect(0,0,1,nAltImg) operation:NSCompositeSourceOver fraction:1.0];		  
   }else{
    frame=NSInsetRect(frame,0,0);
    rcLeft=frame;
    rcLeft.size.width=nAmpImg;

    if([super isSelectedForSegment:segment])
     [aImageLeft drawInRect:rcLeft fromRect:NSMakeRect(0,0,nAmpImg,nAltImg) operation:NSCompositeSourceOver fraction:1.0];		  
    else
     [aImageLeftNormal drawInRect:rcLeft fromRect:NSMakeRect(0,0,nAmpImg,nAltImg) operation:NSCompositeSourceOver fraction:1.0];		  
   
    frame.origin.x=rcLeft.size.width;
    frame.size.width-=rcLeft.size.width;
    if([super isSelectedForSegment:segment])
     [aImageMiddle drawInRect:frame fromRect:NSMakeRect(0,0,1,nAltImg) operation:NSCompositeSourceOver fraction:1.0];		  
    else
     [aImageMiddleNormal drawInRect:frame fromRect:NSMakeRect(0,0,1,nAltImg) operation:NSCompositeSourceOver fraction:1.0];		
   }  
  }
  
  //Ultimo segmento
  if(segment == (nSegment-1)){
   if(bPressed){
    frame=NSInsetRect(frame,0,0);
    frame.size.width-=nAmpImg;
	[aImageMiddlePressed drawInRect:frame fromRect:NSMakeRect(0,0,1,nAltImg) operation:NSCompositeSourceOver fraction:1.0];		  
    rcRight=frame;
    rcRight.size.width=nAmpImg;
    rcRight.origin.x+=frame.size.width;
    [aImageRightPressed drawInRect:rcRight fromRect:NSMakeRect(0,0,nAmpImg,nAltImg) operation:NSCompositeSourceOver fraction:1.0];		  
   }else{
    frame=NSInsetRect(frame,0,0);
    frame.size.width-=nAmpImg;
    if([super isSelectedForSegment:segment])
     [aImageMiddle drawInRect:frame fromRect:NSMakeRect(0,0,1,nAltImg) operation:NSCompositeSourceOver fraction:1.0];		  
    else   
     [aImageMiddleNormal drawInRect:frame fromRect:NSMakeRect(0,0,1,nAltImg) operation:NSCompositeSourceOver fraction:1.0];		  

    rcRight=frame;
    rcRight.size.width=nAmpImg;
    rcRight.origin.x+=frame.size.width;

   if([super isSelectedForSegment:segment])
    [aImageRight drawInRect:rcRight fromRect:NSMakeRect(0,0,nAmpImg,nAltImg) operation:NSCompositeSourceOver fraction:1.0];		  
   else
    [aImageRightNormal drawInRect:rcRight fromRect:NSMakeRect(0,0,nAmpImg,nAltImg) operation:NSCompositeSourceOver fraction:1.0];		  
  }
 }
 
 NSString *aLabel=[super labelForSegment:segment];
 bCenterText=TRUE;
 NSImage *aImage=[super imageForSegment:segment];
 if(aImage!=nil){
  if(aLabel==nil)
   ptImagePos.x=rcImagePos.origin.x+(rcImagePos.size.width-[aImage size].width)/2;
  else
   ptImagePos.x=rcImagePos.origin.x+2;
   
  ptImagePos.y=rcImagePos.origin.y+(rcImagePos.size.height-[aImage size].height)/2;
  [aImage setFlipped:YES];
  [aImage drawAtPoint:ptImagePos fromRect:NSMakeRect(0,0,[aImage size].width,[aImage size].height) operation:NSCompositeSourceOver fraction:1.0];
  [aImage setFlipped:NO];

  rcImagePos.origin.x+=[aImage size].width+2;
  bCenterText=FALSE;
 }
  
 if( aLabel != nil){
  [self drawText:rcImagePos forLabel:aLabel];
 }
  
}

- (BOOL)startTrackingAt:(NSPoint)startPoint inView:(NSView *)controlView
{
    BOOL ret = [super startTrackingAt:startPoint inView:controlView];
    ptLastHitPoint=startPoint;
    return ret;
}

- (BOOL)continueTracking:(NSPoint)lastPoint at:(NSPoint)currentPoint inView:(NSView *)controlView
{
    BOOL ret = [super continueTracking:lastPoint at:currentPoint inView:controlView];

    return ret;
}

- (void)stopTracking:(NSPoint)lastPoint at:(NSPoint)stopPoint inView:(NSView *)controlView mouseIsUp:(BOOL)flag
{
    [super stopTracking:lastPoint at:stopPoint inView:controlView mouseIsUp:flag];
}


 //scrive il testo nel segmento
- (void) drawText:(NSRect)cellFrame forLabel:(NSString*) theLabel{
 NSString *infoString = [NSString stringWithFormat:@"<span style=\"font-size: 10px; font-family: 'Lucida Grande'; color: #1234ad;\"><strong>%@</strong></span>",theLabel];
 NSAttributedString * attributedInfoString = [[NSAttributedString alloc] initWithHTML:[infoString dataUsingEncoding:NSASCIIStringEncoding] documentAttributes:NULL];
 NSPoint stringPoint;
 if(bCenterText)
  stringPoint.x =  cellFrame.origin.x+(cellFrame.size.width / 2 - [attributedInfoString size].width / 2);
 else
  stringPoint.x =  cellFrame.origin.x+4;
 stringPoint.y =  cellFrame.origin.y+ (cellFrame.size.height-[attributedInfoString size].height)/2;
 [attributedInfoString drawAtPoint:stringPoint];
 [attributedInfoString release];
}

-(void) setImageButtonWithName:(NSString *) newImageButton{
 NSRect rcInvalidate= [[self controlView] bounds];
 NSMutableString *tmpName=nil;

 //gestisco un massimo di 9 differenti immagini associate ai rispettivi stati e deve essere TIFF
 // il nome effettivo dell'immagine è la radice (newImageButton) + N + L  (Normale con stato a Left)
 // il nome effettivo dell'immagine è la radice (newImageButton) + N + M  (Normale con stato a Middle)
 // il nome effettivo dell'immagine è la radice (newImageButton) + N + R  (Normale con stato a Right)
 // il nome effettivo dell'immagine è la radice (newImageButton) + P + L  (Premuto con stato a Left)
 // il nome effettivo dell'immagine è la radice (newImageButton) + P + M  (Premuto con stato a Middle)
 // il nome effettivo dell'immagine è la radice (newImageButton) + P + R  (Premuto con stato a Right)
 // il nome effettivo dell'immagine è la radice (newImageButton) + S + L  (Selezionato con stato a Left)
 // il nome effettivo dell'immagine è la radice (newImageButton) + S + M  (Selezionato con stato a Middle)
 // il nome effettivo dell'immagine è la radice (newImageButton) + S + R  (Selezionato con stato a Right)
 
 tmpName=[NSMutableString stringWithFormat:@"%@-%@-%@.tiff",newImageButton,@"S",@"L"];
 [aImageLeft release];
 aImageLeft=[[NSImage  imageNamed:tmpName] retain];
 
 tmpName=[NSMutableString stringWithFormat:@"%@-%@-%@.tiff",newImageButton,@"S",@"M"];
 [aImageMiddle release];
 aImageMiddle=[[NSImage  imageNamed:tmpName] retain];

 tmpName=[NSMutableString stringWithFormat:@"%@-%@-%@.tiff",newImageButton,@"S",@"R"];
 [aImageRight release];
 aImageRight=[[NSImage  imageNamed:tmpName] retain];

 tmpName=[NSMutableString stringWithFormat:@"%@-%@-%@.tiff",newImageButton,@"N",@"L"];
 [aImageLeftNormal release];
 aImageLeftNormal=[[NSImage  imageNamed:tmpName] retain];

 tmpName=[NSMutableString stringWithFormat:@"%@-%@-%@.tiff",newImageButton,@"N",@"M"];
 [aImageMiddleNormal release];
 aImageMiddleNormal=[[NSImage  imageNamed:tmpName] retain];

 tmpName=[NSMutableString stringWithFormat:@"%@-%@-%@.tiff",newImageButton,@"N",@"R"];
 [aImageRightNormal release];
 aImageRightNormal=[[NSImage  imageNamed:tmpName] retain];

 tmpName=[NSMutableString stringWithFormat:@"%@-%@-%@.tiff",newImageButton,@"P",@"L"];
 [aImageLeftPressed release];
 aImageLeftPressed=[[NSImage  imageNamed:tmpName] retain];

 tmpName=[NSMutableString stringWithFormat:@"%@-%@-%@.tiff",newImageButton,@"P",@"M"];
 [aImageMiddlePressed release];
 aImageMiddlePressed=[[NSImage  imageNamed:tmpName] retain];

 tmpName=[NSMutableString stringWithFormat:@"%@-%@-%@.tiff",newImageButton,@"P",@"R"];
 [aImageRightPressed release];
 aImageRightPressed=[[NSImage  imageNamed:tmpName] retain];

 [[self controlView] setNeedsDisplayInRect:rcInvalidate ];
}

@end
